/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1999, ADLink Technology Inc.  All rights reserved.  ;;
;;                                                                         ;;
;;      File Name : 7233int.c                                              ;;
;;      Purpose   : This sample program demonstrates how handle interrupt  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/
#include <stdio.h>
#include <unistd.h>
#include "dask.h"
#include "conio.h"

int int_count=0;
I16 card=-1;

void sig1_handler( int signo )
{
   int_count++;
   printf("INT count = %d\n\n", int_count);
   printf("press ENTER for exit\n" );

   return;
}


int main(void)
{
    int  err;

    setbuf( stdout, NULL );
    printf("PCI-7233 Interrupt Sample (INT1)\n\n");
    printf("This program shows the number of occurrence of INT1 interupt.\n");
    printf("INT1 interrupt is generated by change of state of DI bit 0-15.\n");

    printf("Press ENTER for exit\n\n" );

    int_count = 0;

    if ((card=Register_Card(PCI_7233, 0)) < 0) {
      printf ("Can't open device file: PCI7233\n");
      exit(-1);
    }

    err = DIO_SetDualInterrupt(card, INT1_EXT_SIGNAL, INT2_DISABLE, sig1_handler, NULL );
    if( err != NoError ){
       printf(" error from DIO_SetDualInterrupt : %d \n" , err );
       goto exit_after_error;
    }

    getchar();

    DIO_SetDualInterrupt(card, INT1_DISABLE, INT2_DISABLE, NULL, NULL);
exit_after_error:
    if (card >= 0) Release_Card(card);
    exit(0);
}
